import java.sql.*;
/***************************************************************************/
/*    Uebung 20                                                            */
/*                                                                         */
/*    Anwendung fr SQL-Zugriffe in java                                   */
/*                                                                         */
/*    Version 3  fr eclipse_jdk                                           */
/*                                                                         */
/***************************************************************************/

public class loesung22 {

	public static void main(String[] args)
	{
		Connection conn = null;
		Statement  stmt = null;
        int        anz  = 0;
		
		String drop1 = "drop table delivery";
		String drop2 = "drop table product";
		String drop3 = "drop table vendor";
		
		
		String create1 = "create table vendor (" +
						 "LNR  NUMBER(2)    CONSTRAINT  vendor_PK    PRIMARY KEY," +
						 "Name VARCHAR2(20) NOT NULL," +
						 "Ort  VARCHAR2(20) NOT NULL," +
						 "Status  NUMBER(2) CONSTRAINT  Stat_Werte    CHECK (Status in (10,20,30)))";
		
		String create2 = "create table product (" +
		                 "ANR  CHAR(2) CONSTRAINT  product_PK  PRIMARY KEY," +
                         "Bezeichnung   VARCHAR2(20) NOT NULL," +
                         "Laenge  NUMBER(3)  CONSTRAINT  Laenge_pos  CHECK (Laenge > 0)," +
                         "Breite  NUMBER(3)," +
                         "Material  VARCHAR2(20) NOT NULL," +
                         "LNR     NUMBER(2) CONSTRAINT  product_vendor_FK REFERENCES vendor (LNR), " +
                         "CONSTRAINT    Breite_pos CHECK (Breite > 0))";
		
		String create3 = "create table delivery (" +
		                 "LNR          NUMBER(2)    CONSTRAINT  delivery_vendor_FK REFERENCES vendor (LNR)," + 
		                 "ANR          CHAR(2)      CONSTRAINT  delivery_product_FK   REFERENCES product," +
		                 "Mindestmenge NUMBER(3)    CONSTRAINT  Mindestmenge_pos CHECK (Mindestmenge > 0)," +
		                 "Lieferzeit   NUMBER(3)    CONSTRAINT  Lieferzeit_pos   CHECK (Lieferzeit >= 0)," +
		                 "Preis        NUMBER(5,2)  CONSTRAINT  Preis_pos        CHECK (Preis >= 0)," +
		                 "CONSTRAINT delivery_PK PRIMARY KEY (LNR,ANR))";
		
		String init1 = "insert into vendor (select * from Lieferant)";
		String init2 = "insert into product (select * from Artikel)";
		String init3 = "insert into delivery (select * from liefert)";
		
		String insert1 = "insert into product values ('B1','Bett',200,100,'Holz',null)";
        String insert2 = "insert into product values ('B2','Bett',200,150,'Holz',null)";
        String insert3 = "insert into vendor values (7,'Schulze','Gera',10)";
   	
        String update1 = "update delivery set preis = preis * 1.1  where LNR = 8";
        
        String delete1 = "delete from delivery where ANR ='S1'";
        String delete2 = "delete from product  where ANR ='S1'";
        
        String insert4 = "insert into delivery (" +
	                     "select 7,ANR,MIndestmenge, Lieferzeit, Preis*0.85 " +  
	                     "from delivery where LNR = 8)";
		try
		{
			DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
		    conn = DriverManager.getConnection 
		       ("jdbc:oracle:thin:@gw3svr32.gw.net.fh-jena.de:1521:oracle11", "ss10etxyz", "geheim");
			System.out.println("Verbindung zur Oracle Datenbank Orcale 11g hergestellt !");
			stmt = conn.createStatement();
		}
		catch (SQLException e)
	    {
			System.out.println(e);
			return;
	    }
		
		try
		{	
			stmt.execute(drop1);
		}
		catch (SQLException e)
	    {
			System.out.println(e);	
	    }
		
		try
		{	
			stmt.execute(drop2);
		}
		catch (SQLException e)
	    {
			System.out.println(e);	
	    }

		try
		{	
			stmt.execute(drop3);
		}
		catch (SQLException e)
	    {
			System.out.println(e);	
	    }

		
		try
		{	
			stmt.execute(create1);
			stmt.execute(create2);
			stmt.execute(create3);
			System.out.println("Tabellen vendor, product und delivery angelegt !");
			
			stmt.execute(init1);
			stmt.execute(init2);
			stmt.execute(init3);
			System.out.println("Tabellen vendor, product und delivery initialisiert !");

			stmt.execute(insert1);
			stmt.execute(insert2);
			System.out.println("Zwei Zeilen in product angelegt !");

			stmt.execute(insert3);
			System.out.println("Eine Zeile in vendor angelegt !");

			anz = stmt.executeUpdate(update1);
			System.out.println(anz + " Zeile(n) in delivery geaendert !");
		
			anz = stmt.executeUpdate(delete1);
			System.out.println(anz + " Zeile(n) in deliyery geloescht !");

			anz = stmt.executeUpdate(delete2);
			System.out.println(anz + " Zeile(n) in product geloescht !");

			anz = stmt.executeUpdate(insert4);
			System.out.println(anz + " Zeile(n) in delivery eingefuegt !");
			
		}
		catch (SQLException e)
	    {
			System.out.println(e);
	    }
		
        try
        {
        	stmt.close();
        	conn.close();
        }
        catch (SQLException e)
        {
        	System.out.println(e);
        }
        return;
	}
}
