/***************************************************************************/
/*    Uebung 19                                                            */
/*                                                                         */
/*    Komplexe Abfragen                                                    */
/*                                                                         */
/*    Version 2  fuer Oracle 11g und SQL Developer 2.1                     */
/*                                                                         */
/***************************************************************************/
create or replace view Abf_a1_max as 
(SELECT to_CHAR(DATUM,'YYYY') AS JAHR, Max(T_AVG) AS T_AVG
 FROM MESSWERT
 group by to_CHAR(DATUM,'YYYY'));

select * from Abf_a1_max;

create or replace view Abf_a1_min as 
(SELECT to_CHAR(DATUM,'YYYY') AS JAHR, Min(T_AVG) AS T_AVG
 FROM MESSWERT
 GROUP BY to_CHAR(MESSWERT.DATUM,'YYYY'));

select * from Abf_a1_min;

create or replace view Abf_a1_t1 as 
(SELECT DISTINCT to_char(DATUM,'DD.MM.YYYY') as Datum, Uhrzeit, 
                 T_AVG AS Temp,
                 'niedrigste Temperatur' AS "Min/Max",
                 to_CHAR(DATUM,'YYYY') AS JAHR 
 FROM MESSWERT natural join Abf_a1_min 
 where to_CHAR(MESSWERT.DATUM,'YYYY')= Jahr);

select * from Abf_a1_t1 order by jahr;

create or replace view Abf_a1_t2 as 
(SELECT DISTINCT to_char(DATUM,'DD.MM.YYYY') as Datum, Uhrzeit, 
                 T_AVG AS Temp,
                 'hoechste Temperatur' AS "Min/Max",
                 to_CHAR(DATUM,'YYYY') AS JAHR
 FROM MESSWERT natural join  Abf_a1_max 
 where to_CHAR(DATUM,'YYYY')= Jahr);

select * from Abf_a1_t2 order by jahr;

create or replace view Abf_a1 as 
(select * from Abf_a1_t1 
 UNION 
 select * from Abf_a1_t2);

select * from Abf_a1 order by Jahr, 4, Uhrzeit;

create or replace view Abf_a2_diff as 
(select M1.DATUM, Abs(M1.T_AVG - M2.T_AVG) Diff, to_char(M1.Datum,'YYYY') Jahr
 from MESSWERT M1, MESSWERT M2
 where M1.DATUM = M2.DATUM
   and M1.UHRZEIT='12:00'
   and M2.UHRZEIT='24:00');

select * from Abf_a2_diff order by jahr;

create or replace view Abf_a2_max as 
(select Jahr,Max(Abf_a2_diff.Diff) AS Diff
 from   Abf_a2_diff group by Jahr);

select * from Abf_a2_max order by jahr;

create or replace view Abf_a2 as 
(select Jahr,to_char(DATUM,'DD.MM.YYY') Datum, Diff AS Temperatur_Differenz
 from   Abf_a2_diff natural join Abf_a2_max 
);
   
select * from Abf_a2 order by Jahr;

create or replace view Abf_b1_liste as 
(select DISTINCT JENAH_HAL.NAME, JENAH_LIN.NR
 from JENAH_HAL, JENAH_LIN
 where JENAH_HAL.S_MAST = JENAH_LIN.L_MAST);

select * from Abf_b1_Liste order by name;

create or replace view Abf_b1_ges as 
(select NAME, Count(NR) AS Anzahl
 from Abf_b1_liste
 group by NAME);

select * from Abf_b1_ges order by name;

create or replace view Abf_b1_max as 
(SELECT Max(Anzahl) AS Anzahl
FROM Abf_b1_ges);

select * from Abf_b1_max;

create or replace view Abf_b1 as 
(select NAME, Anzahl
 from Abf_b1_ges natural join  Abf_b1_max);

select * from Abf_b1;

create or replace view Abf_b2_max as
(select NR, RICHTUNG, Max(STRECKE) AS STRECKE, Max(ZEIT) AS ZEIT, ART
 from JENAH_LIN
 group by NR, RICHTUNG, ART);

select * from Abf_b2_max order by Nr, Richtung;

create or replace view Abf_b2_art as 
(select ART, Sum(STRECKE) AS STRECKE, Sum(ZEIT) AS ZEIT
 from Abf_b2_max
 group by ART);

select * from Abf_b2_art;

create or replace view Abf_b2 as 
(select ART, STRECKE AS "Strecke(Meter)", ZEIT AS "Zeit(Minuten)",  
 Round((STRECKE/ZEIT)*60/1000,2) AS "Geschwindigkeit(km/h)"  from Abf_b2_art);

select * from Abf_b2;

create or replace view Abf_c1 as 
(select distinct VERANSTALTUNG.WOCHENTAG, VERANSTALTUNG.TITEL AS Veranstaltung, RAUM.NAME AS Raum, STUDSET.Name AS Studentensets
 from STUDSET, VERANSTALTUNG_STUDSET, Veranstaltung, DOZENT, VERANSTALTUNG_DOZENT, VERANSTALTUNG_RAUM, RAUM
 where DOZENT.DNR                 = VERANSTALTUNG_DOZENT.D_NR 
   and VERANSTALTUNG_DOZENT.V_NR  = VERANSTALTUNG.ID 
   and VERANSTALTUNG_STUDSET.V_NR = VERANSTALTUNG.ID 
   and VERANSTALTUNG.ID           = VERANSTALTUNG_RAUM.V_NR 
   and VERANSTALTUNG_RAUM.R_NR    = RAUM.RNR
   and STUDSET.SNR                = VERANSTALTUNG_STUDSET.S_NR
   and DOZENT.NAME                = 'Cleef' 
   and STUDSET.NAME               Like  '%ET(BA)6.%');

select * from Abf_c1
order by Veranstaltung, STUDENTENSETS;

create or replace view Abf_c2_ind as 
(select WOCHE.WNR, STUDSET.SNR
 from WOCHE, STUDSET, Student
 where WOCHE.NAME  = 'SW 14'
   and STUDENT.SNR = STUDSET.SNR 
   and STUDENT.Nachname = 'Mustermann');

select * from Abf_c2_ind;

create or replace view Abf_c2 as 
(select WID, WOCHENTAG, to_char(BEGINN,'HH24:MI') Beginn, to_char(ENDE,'HH24:MI') AS Ende, TITEL, NAME AS Raum
 from  WEEK, Abf_c2_ind, VERANSTALTUNG_STUDSET, VERANSTALTUNG_WOCHE, RAUM, VERANSTALTUNG_RAUM, VERANSTALTUNG 
 where SNR = S_NR
   and WNR = W_NR 
   and RNR = R_NR
   and ID  = VERANSTALTUNG_RAUM.V_NR
   and ID  = VERANSTALTUNG_STUDSET.V_NR
   and ID  = VERANSTALTUNG_WOCHE.V_NR
   and TAG = WOCHENTAG);

select * from Abf_c2
order by WID, Beginn;

create or replace view Abf_c3_bas as 
(select W_NR, WID, WOCHENTAG, Count(ID) AS Anzahl
 from  WEEK, VERANSTALTUNG, VERANSTALTUNG_WOCHE 
 where ID =  V_NR
   and TAG = WOCHENTAG
group by W_NR, WID, WOCHENTAG);

select * from Abf_c3_bas order by W_NR, WID;

create or replace view Abf_c3_ext as
(select Max(Anzahl) AS MaxAnzahl, Min(Anzahl) AS MinAnzahl
 from Abf_c3_bas);

create or replace view Abf_c3_t1 as
(select NAME AS Semesterwoche, WOCHENTAG, to_char(DATUM + WID - 1,'DD.MM.YYYY') AS Tag, Anzahl AS Veranstaltungszahl
 from   Abf_c3_ext, WOCHE, Abf_c3_bas 
 where WNR = W_NR
   and MaxAnzahl = Anzahl);

select * from Abf_c3_t1;

create or replace view Abf_c3_t2 as
(select NAME AS Semesterwoche, WOCHENTAG, to_char(DATUM + WID - 1,'DD.MM.YYYY') AS Tag, Anzahl AS Veranstaltungszahl
 from   Abf_c3_ext, WOCHE, Abf_c3_bas 
 where WNR = W_NR
   and MinAnzahl = Anzahl);

select * from Abf_c3_t2;

create or replace view Abf_c3 as
(select * from Abf_c3_t2
 UNION 
 select * from Abf_c3_t1);

select Semesterwoche, Wochentag, Tag, VERANSTALTUNGSZAHL from Abf_c3 order by Semesterwoche;

create or replace view Abf_d1 as
(select MANNSCHAFT.MSID, MANNSCHAFT.NAME
 from   SPIELZEIT, MANNSCHAFT, MITGLIED, SPIELKLASSENSAISON, SPIELKLASSE
 where  MSID             = MS_ID
   and  SS_ID            = SSID
   and  SZID             = SZ_ID
   and  SK_ID            = SKID
   and  SPIELKLASSE.NAME = '1. Bundesliga' 
   and  SAISON           = '2002/2003');

select * from Abf_d1
order by NAME;
//
//   Bestimme die mannschafts-ID der mannschaften, die Mitglied der 1. Bundesliga 
//   in der Saison 2000/2001 waren
//
create or replace view Abf_d2_s1 as
(select MSID
 from   SPIELZEIT, MANNSCHAFT, MITGLIED, SPIELKLASSENSAISON, SPIELKLASSE 
 where  MSID             = MS_ID
   and  SS_ID            = SSID
   and  SZID             = SZ_ID
   and  SK_ID            = SKID
   and  SPIELKLASSE.NAME =  '1. Bundesliga'
   and  SAISON           =  '2000/2001');

select * from Abf_d2_s1  order by MSID;

//
//   Bestimme die mannschafts-ID der mannschaften, die Mitglied der 1. Bundesliga 
//   in der Saison 2001/2002 waren
//
create or replace view Abf_d2_s2 as
(select MSID
 from   SPIELZEIT, MANNSCHAFT, MITGLIED, SPIELKLASSENSAISON, SPIELKLASSE 
 where  MSID             = MS_ID
   and  SS_ID            = SSID
   and  SZID             = SZ_ID
   and  SK_ID            = SKID
   and  SPIELKLASSE.NAME =  '1. Bundesliga'
   and  SAISON           =  '2001/2002');

select * from Abf_d2_s2 order by MSID;

//
//   Bestimme die mannschafts-ID der mannschaften, die Mitglied der 1. Bundesliga 
//   in der Saison 2002/2003 waren
//
create or replace view Abf_d2_s3 as
(select MSID
 from   SPIELZEIT, MANNSCHAFT, MITGLIED, SPIELKLASSENSAISON, SPIELKLASSE 
 where  MSID             = MS_ID
   and  SS_ID            = SSID
   and  SZID             = SZ_ID
   and  SK_ID            = SKID
   and  SPIELKLASSE.NAME =  '1. Bundesliga'
   and  SAISON           =  '2002/2003');

select * from Abf_d2_s3 order by MSID;

//
//    Bestimme die Mannschaften, die in der Saison 2001/2002 Mitglied und in der Saison 2000/2001
//    noch kein Mitglied der 1. Bundesliga waren (Aufsteiger der Saison 2001/2002) 
//
create or replace view Abf_d2_t1 as
(select MANNSCHAFT.NAME, 'Aufsteiger' AS "Aufsteiger/Absteiger"
 from   MANNSCHAFT, Abf_d2_s2 
 where  MANNSCHAFT.MSID = Abf_d2_s2.MSID
   and  MANNSCHAFT.MSID Not In (select * from Abf_d2_s1));

select * from Abf_d2_t1;

//
//    Bestimme die Mannschaften, die in der Saison 2001/2002 Mitglied und in der Saison 2002/2003
//    kein Mitglied der 1. Bundesliga mehr waren (Absteiger der Saison 2001/2002) 
//
create or replace view Abf_d2_t2 as
(select MANNSCHAFT.NAME, 'Absteiger' AS "Aufsteiger/Absteiger"
 from   MANNSCHAFT, Abf_d2_s2 
 where  MANNSCHAFT.MSID = Abf_d2_s2.MSID
   and  MANNSCHAFT.MSID Not In (select * from Abf_d2_s3));

select * from Abf_d2_t2;

//
//   Fasse die Ergebnisse der beiden letzten Abfragen zusammen
//
create or replace view Abf_d2 as
(select * from Abf_d2_t1
 UNION 
 select * from Abf_d2_t2);
//
//   Ausfuehren der Loesung ABF_D2   
//
select * from Abf_d2
order by "Aufsteiger/Absteiger", NAME;
//
//   Bestimme alle Mannschaften, die das Wort 'Erfurt' im Vereinsnamen haben und alle Klassen
//   in denen diese Mannschaften Mitlied in mindestens einer Saison waren (Duplikate entfernen) 
//
create or replace view Abf_d3 as
(select distinct MANNSCHAFT.NAME AS Verein, SPIELKLASSE.NAME AS Spielklasse
 from   MANNSCHAFT, MITGLIED, SPIELKLASSENSAISON, SPIELKLASSE
 where  MSID  = MS_ID
   and  SS_ID = SSID 
   and  SK_ID = SKID
   and  MANNSCHAFT.NAME Like '%Erfurt%');
//
//   Ausfuehren der Loesung ABF_D3   
//
select * from Abf_d3;
